import pygame, sys, os, math
from pygame.locals import *

def rotate_player_to_angle_and_translate(arena,player_image, angle,curPosX,curPosY):
    """rotate a Surface, maintaining position."""
    rot_sprite = pygame.transform.rotozoom(player_image, angle,1) #This rotates an image around angle degrees
    rect = rot_sprite.get_rect(center=(curPosX,curPosY)) #This centers the rotated image on its old position
    arena.blit(rot_sprite, rect) #Updates the screen
    return rot_sprite


def draw_square(arena,targetPosX,targetPosY,color=(0,0,0),size = 10):
    """draws a rectangle on the screen"""
    target = pygame.Rect(targetPosX-(size/float(2)), targetPosY-(size/float(2)), size, size) #create the rectangle
    pygame.draw.rect(arena, color, target) #Draw it on the screen

    
############## CHANGE THIS FUNCTION TO CALCULATE THE CORRECT ANGLE ##############     
def calculate_angle_to_target(player_pos_x,player_pos_y,target_pos_x,target_pos_y):
    deltaX = float(targetPosX - player_pos_x)
    deltaY = float(targetPosY - player_pos_y)
    hypo = math.sqrt(deltaX**2 + deltaY**2)
    
    angleRadians = math.asin(abs(deltaY)/hypo)
    
    
    
    if deltaX <0 and deltaY < 0:
         angleRadians = math.pi - angleRadians
    elif deltaX <0 and deltaY > 0:
         angleRadians = math.pi + angleRadians
    elif deltaX > 0 and deltaY > 0:
         angleRadians = 2* math.pi - angleRadians
    elif deltaX > 0 and deltaY < 0 :
         angleRadians = angleRadians  
    
    
    return math.degrees(angleRadians)

#Initial Position and Rotation of the Player
#Change these during the loop to update the players Position    
player_pos_x = 400 
player_pos_y = 300
playerHeading = 0

#A list of possible target positions
target_x_list = [100,700,700,100]
target_y_list = [500,500,100,100]
target_num = 0 #Current active target

pygame.init() #Initialize the pygame module
screen = pygame.display.set_mode((800, 600)) #Define a 800,600 screen

player_original = pygame.image.load(os.path.join("braitenberg.png")) #Load the braitenberg image. It has to be located in the same folder as this script!
player_original.convert() #This function converts the loaded image to game sprite

while True: #The pygame Loop runs forever
    for event in pygame.event.get(): #This loop makes sure that the X-Button works!
            if event.type == QUIT:
                pygame.quit() #Quit the game in case of x-button press
                sys.exit()


    screen.fill((255,255,255)) # In each loop we will redraw the screen with white color
    
    
    # This part cycles through the different target positions
    targetPosX = target_x_list[target_num] #Select target_num x Value
    targetPosY = target_y_list[target_num] #Select target_num y Value
    draw_square(screen,targetPosX,targetPosY,(0,0,255),25) # Draw a square at the target position with size 10 and blue color
    target_num = (target_num +1) % 4 #Increase target_num. Use modulo to keep it between 0 and 3
    

    ####################### This is the function call that you will edit ###################   
    playerHeading = calculate_angle_to_target(player_pos_x,player_pos_y,targetPosX,targetPosY)
    
    #The player Positions stay the same for now
    player_pos_x = player_pos_x  #Change the positions here to translate the player
    player_pos_y = player_pos_y
    
    #These two functions apply the calculated rotation and translation of the player
    rotate_player_to_angle_and_translate(screen,player_original,playerHeading,player_pos_x,player_pos_y)
    #cur_player = set_player_pos(screen,cur_player,player_pos_x,player_pos_y)
        
		
    pygame.display.flip() # This shows all the updates
    pygame.time.delay(750) #This puts a delay between each loop iteration    
pygame.quit()
